---
title: MediaDeviceInfo
slug: Web/API/MediaDeviceInfo
tags:
  - API
  - Audio
  - Interface
  - Media
  - Media Device Info
  - Media Devices
  - MediaDevicesInfo
  - Reference
  - Video
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong><code>MediaDeviceInfo</code></strong> interface contains information that describes a single media input or output device.</span> The list of devices obtained by calling {{domxref("MediaDevices.enumerateDevices", "navigator.mediaDevices.enumerateDevices()")}} is an array of <code>MediaDeviceInfo</code> objects, one per media device.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("MediaDeviceInfo.deviceId")}}{{readonlyinline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} that is an identifier for the represented device that is persisted across sessions. It is un-guessable by other applications and unique to the origin of the calling application. It is reset when the user clears cookies (for Private Browsing, a different identifier is used that is not persisted across sessions).</dd>
 <dt>{{domxref("MediaDeviceInfo.groupId")}}{{readonlyinline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} that is a group identifier. Two devices have the same group identifier if they belong to the same physical device — for example a monitor with both a built-in camera and a microphone.</dd>
 <dt>{{domxref("MediaDeviceInfo.kind")}}{{readonlyinline}}</dt>
 <dd>Returns an enumerated value that is either <code>"videoinput"</code>, <code>"audioinput"</code> or <code>"audiooutput"</code>.</dd>
 <dt>{{domxref("MediaDeviceInfo.label")}}{{readonlyinline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} that is a label describing this device (for example "External USB Webcam").</dd>
</dl>

<div class="note">
<p>For security reasons, the <code>label</code> field is always blank unless an active media stream exists <em>or</em> the user has granted persistent permission for media device access. The set of device labels could otherwise be used as part of a fingerprinting mechanism to identify a user.</p>
</div>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Example">Example</h2>

<p>Here's an example that uses {{domxref("MediaDevices.enumerateDevices", "enumerateDevices()")}} to get a list of devices.</p>

<pre class="brush:js notranslate">if (!navigator.mediaDevices || !navigator.mediaDevices.enumerateDevices) {
  console.log("enumerateDevices() not supported.");
  return;
}

// List cameras and microphones.

navigator.mediaDevices.enumerateDevices()
.then(function(devices) {
  devices.forEach(function(device) {
    console.log(device.kind + ": " + device.label +
                " id = " + device.deviceId);
  });
})
.catch(function(err) {
  console.log(err.name + ": " + err.message);
});
</pre>

<p>This might produce:</p>

<pre class="eval notranslate">videoinput: id = csO9c0YpAf274OuCPUA53CNE0YHlIr2yXCi+SqfBZZ8=
audioinput: id = RKxXByjnabbADGQNNZqLVLdmXlS0YkETYCIbg+XxnvM=
audioinput: id = r2/xw1xUPIyZunfV1lGrKOma5wTOvCkWfZ368XCndm0=</pre>

<p>or if one or more media streams are active, or if persistent permissions have been granted:</p>

<pre class="eval notranslate">videoinput: FaceTime HD Camera (Built-in) id=csO9c0YpAf274OuCPUA53CNE0YHlIr2yXCi+SqfBZZ8=
audioinput: default (Built-in Microphone) id=RKxXByjnabbADGQNNZqLVLdmXlS0YkETYCIbg+XxnvM=
audioinput: Built-in Microphone id=r2/xw1xUPIyZunfV1lGrKOma5wTOvCkWfZ368XCndm0=
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-mediadeviceinfo', 'MediaDevicesInfo')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaDeviceInfo")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li>{{domxref("MediaDevices.enumerateDevices", "navigator.mediaDevices.enumerateDevices()")}}</li>
 <li>{{domxref("MediaDevices.getUserMedia", "navigator.mediaDevices.getUserMedia()")}}</li>
</ul>
